/*
	NXColorList.h
	Application Kit, Release 3.0
	Copyright (c) 1988, 1989, 1990, 1991 NeXT, Inc.  All rights reserved. 
*/

#import <objc/Object.h>
#import <objc/List.h>
#import "color.h"

@interface NXColorList : Object
{
@private
    char *_name;
    char *_printerType;
    char *_fileName;
    id _hashTable;
    id _colors;
    id _delegate;
    id _editor;
    struct _colorListFlags {
	unsigned int colorsLoaded:1;
	unsigned int editable:1;
	unsigned int hasDeviceSpecificLists:1;
	unsigned int generatesNamedColors:1;
	unsigned int dirty:1;
	unsigned int hasFrozen:1;
	unsigned int :0;
    } _flags;
    id _localNames;
    unsigned _reserved[3];
}

+ (List *)availableColorLists;
+ findColorListNamed:(const char *)name;
- init;
- initWithName:(const char *)name;
- initWithName:(const char *)name fromFile:(const char *)path;
- freeAndRemoveFile;
- free;
- (const char *)name;
- (unsigned)colorCount;
- (const char *)nameOfColorAt:(unsigned)index;
- (void)setColorNamed:(const char *)colorName color:(NXColor)color;
- (void)removeColorNamed:(const char *)colorName;
- (NXColor)colorNamed:(const char *)colorName;
- (const char *)localizedNameForColorNamed:(const char *)colorName;
- (BOOL)generatesNamedColors;
- (BOOL)isEditable;
- saveTo:(const char *)path;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

@end

@interface Object (NXColorListDelegate)
- colorListDidChange:list colorName:(const char *)colorName;
@end


